; NUMBER.ASM
; part of Ben's Command Extender
; number handling procs
; 5 Dec 97
; blm
;

; atou
; convert string of decimal numbers in ax to unsigned word
; returns word in ax
atou:
	push    bx
	push    cx
	push    dx
	push    si
	push    ds

	push    cs
	pop     ds
	xor     bx, bx
	mov     si, ax
.nextchar:
	lodsb
	cmp     al, '0'
	jb      .done
	cmp     al, '9'
	ja      .done
	sub     al, '0'
	
	push    ax
	xor     dx, dx
	mov     ax, 10
	mul     bx
	mov     bx, ax
	pop     ax

	xor     ah, ah
	add     bx, ax
	jmp     .nextchar
.done:

	mov     ax, bx
	pop     ds
	pop     si
	pop     dx
	pop     cx
	pop     bx
	ret
	
	
	
; puth
; prints a sixteen bit hexadecimal number
; uses ax as number
puth:
	push    ax
	push    bx
	push    cx
	push    dx
	push    di
	push    ds

	push    cs
	pop     ds
	
	mov     di, string + 4            ;
	mov     byte [di], '$'
	dec     di                        ; point to previous char
	mov     cx, 4                     ; set count

.getchar:
	mov     bx, 10h                   ;
	xor     dx, dx                    ;
	div     bx                        ;
	cmp     dl, 9                     ;
	jg      .alpha                      ;
	add     dl, '0'                   ; convert number to ascii
	jmp     .numeric                   ;
.alpha:
	add     dl, 55                    ;
.numeric:
	mov     byte [di], dl         ; save character
	dec     di                        ; point to previous char
	loop    .getchar                  ; loop 5 times

	mov     dx, string
	mov     ah, 09h
	int     21h
	
	pop     ds
	pop     di
	pop     dx
	pop     cx
	pop     bx
	pop     ax
	ret
	
	
	
; putd
; prints a sixteen bit unsigned decimal number
; uses ax as number
putd:
	push    ax
	push    bx
	push    cx
	push    dx
	push    di
	push    ds

	push    cs
	pop     ds
	
	mov     di, string + 5 ;
	mov     byte [di], '$'  ;
	dec     di
	mov     cx, 5

.getchar:
	mov     bx, 0Ah
	xor     dx, dx
	div     bx   
	add     dl, '0'     
	mov     byte [di], dl
	dec     di     
	loop    .getchar

.ltrimz:
	inc     di
	mov     al, [di]
	cmp     al, '0'
	je      .ltrimz
	cmp     al, '$'
	jne     .not_eos
	dec     di

.not_eos
	mov     dx, di
	mov     ah, 09h
	int     21h

	pop     ds
	pop     di
	pop     dx
	pop     cx
	pop     bx
	pop     ax
	ret
	
	
	
; puto
; print sixteen bit octal number
; uses ax as number
puto:   
	push    ax
	push    bx
	push    cx
	push    dx
	push    di
	push    ds

	push    cs
	pop     ds

	mov     di, string + 6 ;
	mov     byte [di], '$'  ;
	dec     di
	mov     cx, 6

.getchar:
	mov     bx, 08h
	xor     dx, dx
	div     bx   
	add     dl, '0'     
	mov     byte [di], dl
	dec     di     
	loop    .getchar

.ltrimz:
	inc     di
	mov     al, [di]
	cmp     al, '0'
	je      .ltrimz
	cmp     al, '$'
	jne     .not_eos
	dec     di

.not_eos
	mov     dx, di
	mov     ah, 09h
	int     21h

	pop     ds
	pop     di
	pop     dx
	pop     cx
	pop     bx
	pop     ax
	ret
	


; putb
; print sixteen bit number as binary
putb:
	push    ax
	push    cx
	push    dx
	
	mov     cx, 10h
.next_bit:  
	rcl     ax, 01h
	jc      .one
	mov     dl, '0'
	jmp     .put
.one:
	mov     dl, '1'
.put:
	push    ax
	mov     ah, 02h
	int     21h
	pop     ax
	loop    .next_bit
	
	pop     dx
	pop     cx
	pop     ax
	ret
	
	


decimal:
	mov     word [cs:show_num], putd
	ret
	
	
	
hexadecimal:
	mov     word [cs:show_num], puth
	ret
	
	
	
octal:
	mov     word [cs:show_num], puto
	ret
	
	

binary:
	mov     word [cs:show_num], putb
	ret

	
	
; number data
show_num        dw putd

