; OUTPUT.ASM
; part of Ben's Command Extender
; output procs
; 5 Dec 97
; blm
;



; eko
; just like dos's echo command except it uses lfon and lfoff
eko:
	push    dx
	
	mov		ax, string
	call    commands
	mov		ax, string
	call    strlen
	and     ax, ax
	jz      .no_tail

	mov		ax, string
	call    puts
	
.no_tail:   
	call    [cs:new_line]
	
	xor		ax, ax
	pop     dx
	ret



; ekof
; a cross between DOS's echo command and C's printf function
ekof:
	push    cx
	push    di
	push    si
	push    ds
	push    es

	mov		ax, string
	call    nextarg     ; skip arg0
	mov		ax, string
	call    nextarg     ; get format string
	
	mov		ax, string
	call    strlen      ; check if anything in string
	and     ax, ax
	jz      .done

	mov     cx, ax
	inc     cx
	mov     ax, cs
	mov     ds, ax
	mov     es, ax
	mov     di, format_string
	mov     si, string
	rep     movsb
	mov     si, format_string

.nextchar:
	lodsb
	and     al, al
	jz      .done
	cmp     al, '%'
	jne     .not_convert
	call    convert
	jmp     .nextchar
.not_convert:
	cmp     al, '\'
	jnz     .not_format
	call    format
	jmp     .nextchar
.not_format:
	call    putc
	jmp     .nextchar

.done:
	xor		ax, ax
	
	pop     es
	pop     ds
	pop     si
	pop     di
	pop     cx
	ret


; part of ekof
; convert decimal values into useful information 
convert:
	push    ax

	mov		ax, string
	call    nextarg
	mov	   	ax, string
	call    strlen
	and     ax, ax
	jnz      .no_error
	pop		ax
	call	putc
	push	ax
	jmp		.done
.no_error:
	mov		ax, string
	call    atou
	mov     word [cs:convert_number], ax

	lodsb
	and     al, al
	jz      .done
	
; binary number
	cmp     al, 'b'
	jne     .not_b
	mov     ax, [cs:convert_number]
	call    putb
	jmp     .done

.not_b:
; ASCII character
	cmp     al, 'c'
	jne     .not_c
	mov     ax, [cs:convert_number]
	call    putc
	jmp     .done

.not_c:
; decimal number
	cmp     al, 'd'
	jne     .not_d
	mov     ax, [cs:convert_number]
	call    putd
	jmp     .done

.not_d:
; keystroke
	cmp		al, 'k'
	jne		.not_k
	mov		cx, [cs:convert_number]
	mov		ah, 05h
	int		16h
	jmp		.done

.not_k
; octal number
	cmp     al, 'o'
	jne     .not_o
	mov     ax, [cs:convert_number]
	call    puto
	jmp     .done

.not_o:
; hexadecimal number
	cmp     al, 'x'
	jne     .not_x
	mov     ax, [cs:convert_number]
	call    puth
	jmp     .done

.not_x:
	pop     ax
	call    putc
	dec     si
	push    ax

.done:
	pop     ax
	ret
	
	
	
; part of ekof
; interpret escape sequences
format:
	push    ax

	lodsb   
	and     al, al
	jz      .done

; null
	cmp		al, '0'
	jne		.not_0
	xor		al, al
	call	putc
	jmp		.done

.not_0:
; bell
	cmp     al, 'a'
	jne     .not_a
	mov     al, 07h
	call    putc
	jmp     .done
	
.not_a:
; backspace
	cmp		al, 'b'
	jne		.not_b
	mov		al, 08h
	call	putc
	jmp		.done
	
.not_b:
; DOS end of file
	cmp		al, 'e'
	jne		.not_e
	mov		al, 1Ah
	call	putc
	jmp		.done

.not_e:
; form feed
	cmp     al, 'f'
	jne     .not_f
	mov     al, 0Ch
	call    putc 
	jmp     .done

.not_f:
; tab
	cmp     al, 't'
	jne     .not_t
	mov     al, 09h
	call    putc
	jmp     .done

.not_t:
; line feed
	cmp     al, 'n'
	jne     .not_n
	call    feed
	jmp     .done

.not_n:
; ANSI escape sequence
	cmp		al, 'x'
	jne		.not_x
	mov		al, 1Bh
	call	putc
	mov		al, '['
	call	putc
	jmp		.done
	
.not_x
	pop		ax
	call	putc
	dec		si
	push	ax
	
.done:
	pop     ax
	ret



; puts
; print string in ax to standard output
puts:
	push    ax
	push    dx
	push    di
	
	mov     di, ax

.next_char:
	mov     dl, [cs:di]
	inc     di
	cmp     dl, 00h
	je      .done
	cmp     dl, 0FFh
	je      .done
	mov     ah, 06h
	int     21h
	jmp     .next_char

.done:
	pop     di
	pop     dx
	pop     ax
	ret


; putc
; print character in al to standard output
putc:
	push    ax
	push    dx

	cmp     al, 0FFh
	je      .done
	mov     dl, al
	mov     ah, 06h
	int     21h

.done:
	pop     dx
	pop     ax
	ret



; output data
format_string   times 256 db 00h
convert_number   dw 0000h
